/*
 * $Header: /u0/casey/src/mcast/libmcast/RCS/mc_getsockname.c,v 1.3 93/01/16 19:44:22 casey Exp $
 */

/*
 * Copyright (c) 1992 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Lawrence Livermore National Laboratory and its
 *	contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static char rcsid[] = "$Header: /u0/casey/src/mcast/libmcast/RCS/mc_getsockname.c,v 1.3 93/01/16 19:44:22 casey Exp $";
static char copyright[] =
    "Copyright (c) 1992 The Regents of the University of California.\n"
    "All rights reserved.\n";
static char classification[] =
    "Unclassified\n";
#endif


/*
 * MCAST SYSLIB PUBLIC: mc_getsockname: getsockname(2) system call emulation
 * routine.
 */


#include "mc_lib.h"


int
mc_getsockname(int s, struct sockaddr *name, int *namelen)
    /*
     * Get local name of a multicast socket.
     */
{
	mc_state *sp = &_mc_state[s];
	struct sockaddr_mcast *np = (struct sockaddr_mcast *)name;
	int len = min(*namelen, sizeof(struct sockaddr_mcast));
	struct sockaddr_mcast tmp;

	if (s < 0 || s >= MC_MAX_CONNECTIONS
	    || !(sp->state & MC_VALID)) {
		/* return(recvfrom(s, buf, len, flags)); */
		errno = EBADF;
		return(-1);
	}
	if (sp->state & MC_CORRUPTED) {
		errno = EIO;
		return(-1);
	}
	/* temped to check to see if socket if bound, but that isn't done for
	   the standard protocols so we won't either */
	tmp.family = sp->family;
	tmp.group = sp->group;
	tmp.member = sp->local;
	(void)memcpy(np, &tmp, len);
	*namelen = len;
	return(0);
}
